/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

This software uses the Graph Template Library (GTL) copyrighted by the
University of Passau, http://www.fmi.uni-passau.de/Graphlet/GTL.
*/

#ifndef GraphClass
#define GraphClass

#include <GTL/graph.h>
#include <GTL/dfs.h>
#include <GTL/debug.h>
#include <cstdlib>
#include <cassert>
#include <fstream>
#include <iostream>
#include <vector.h>
#include "../errors.h"

#ifndef NoSuchEdge
#define NoSuchEdge -1
#endif

////////////////////////////////////////////////////////////////////////////
/**The graph class uses the weighted_graph class to produce input objects.
 * 
 * @param GML_file_name
 * the class reads its input from a GML file.
 *
 * @author Pavel Sumazin and Vinhthuy Phan
 *
 * @see weighted_graph
 */
/**
@author Vinhthuy Phan
@version 1.0
*/
class Graph 
{
private:
  ///
  int **in_list;
  ///
  int **out_list;
  ///
  int num_of_nodes;
  ///
  int num_of_edges;

  /// used to map nodes to their index.
  node_map<int> node_index;
public:

  /// Constructor from a GML file.
  Graph(char *GML_file_name);
  ///
  ~Graph();
  ///
  int * in_edges(int x);
  ///
  int * out_edges(int x);

  /// report the number of nodes.
  static int size;
  ///
  static int get_size();

  /// report the number of edges.
  int get_num_of_edges();
	
  /// display the graph to standard out.
  void display();

  /// return the existence of an edge given by the two nodes it is adjacent to.
  bool edge_exists(int x, int y);
};

#endif
