/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/
#ifndef HILL_CLIMB_CPP
#define HILL_CLIMB_CPP


#include "../basic_search.h"

//----------------------------------------------------------------------------------
// HILLCLIMB
//----------------------------------------------------------------------------------
/**
heuristic
@author Vinhthuy Phan
@version 1.0
*/
template <class T> class HillClimb : public BasicSearch<T> {

public:
  ///
  HillClimb(double running_time, double r_interval, double cp_interval, 
	    Solution<T> * an_init_sol = NULL);
  ///
  ~HillClimb();
  ///
  void search();
  ///
  void search_specific_display(ostream *out);
  ///
  double overhead_time();

};

//#include "permutation.h"
//template class HillClimb<Permutation>;

//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
// IMPLEMENTATIONS
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
template<class T>
HillClimb<T>::HillClimb(double running_time, double r_interval, double cp_interval,
			Solution<T> * an_init_sol) 
  : BasicSearch<T> (running_time, r_interval, cp_interval, an_init_sol)
{

}
//----------------------------------------------------------------------------------
template<class T>
HillClimb<T>::~HillClimb()
{
}
//----------------------------------------------------------------------------------
template<class T>
void HillClimb<T>::search_specific_display(ostream *out)
{
  ;
}
//----------------------------------------------------------------------------------
template<class T>
double HillClimb<T>::overhead_time()
{
  return Global<T>::get_solution_creation_time();
}
//----------------------------------------------------------------------------------
template<class T>
void HillClimb<T>::search()
{
  if(search_stat == stat_terminate) return;

#if 0
  cout << "# HillClimb search begins\n";
#endif
  begin_monitoring();

  Solution<T> neighbor;
  strict_descending(10, false);
  update_best_solution(current_solution);
}
//----------------------------------------------------------------------------------

#endif
