/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/
#include <math.h>
#include <iostream>
#include <fstream>
using namespace std;
using std::endl;
using std::cout;

#include "strings.h"

int String::size = 0;

int String::get_size()
{
  return size;
}

String::String()
{
	strings = NULL;
	number_of_strings = 0;
}

String::String(char *file_name)
{
  unsigned int index; //The string index.
  std::ifstream input(file_name, ios::in);//open the file for reading.
  
  if(!input) error_call(bad_file);//Could not open the file.
  
  input >> number_of_strings;
  strings = new string[number_of_strings + 1];//intialize the string array
  
  for(index=1; index <= number_of_strings; ++index){ //get all the strings.
    input >> strings[index];
  }
  
  size = this->number_of_strings;
}


String::~String()
{
  delete [] strings;
}


void String::display()
{
  unsigned int i;
  cout << number_of_strings <<"\n";
  for(i=1;i<=number_of_strings;i++){
    cout << strings[i] << endl;
  }
}

string & String::operator[](string_index index)
{
  if(index < 1 || index > number_of_strings) error_call(bad_index);
  return strings[index];
}
