/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/
#ifndef STRINGS_H
#define STRINGS_H

#include <string>
#include "../errors.h"


typedef unsigned int string_index;

struct IndexedString {
  string s;
  string_index index;
};

typedef struct IndexedString indexed_string;

/**The string class.
 *
 * The string class is designed to read in a file in SML format, given below.
 * It stores strings and provides for functions that access them.
 * Written to support cost functions for Longest Common Superstring,
 * Shortest Common Superstring and Statifiability
 *
 * SML format:
 * n
 * s_1....
 * s_2....
 * ...
 * s_n....
 */
/**
@author Vinhthuy Phan
@version 1.0
*/
class String
{
private:
  /// An array of strings. Index starts from 0
  string *strings;

  /// the number of strings.
  unsigned int number_of_strings;
  ///
  static int size;
 
public:
	String();

  ///
  String(char *file_name);
  ///
  ~String();
  ///
  string & operator[](string_index index);
  ///
  static int get_size();
  ///
  void display();
};

#endif
