/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/
//--------------------------------------------------------------------
//
// CircularPermutation.cpp: implementation of the CircularPermutation class.
//
//--------------------------------------------------------------------
#include <cstdlib>
#include "circular_permutation.h"

//--------------------------------------------------------------------------
//---- Main constructor
//--------------------------------------------------------------------------
CircularPermutation::CircularPermutation() : CombinatorialObject()
{
  perm = element;
  inverse_perm = element_index;
}
//--------------------------------------------------------------------------
CircularPermutation::CircularPermutation(int n) : CombinatorialObject(n)
{
  perm = element;
  inverse_perm = element_index;
}
//--------------------------------------------------------------------------
//---- Copy constructor
//--------------------------------------------------------------------------
CircularPermutation::CircularPermutation(const CircularPermutation &p) : CombinatorialObject(p)
{
  perm = element;
  inverse_perm = element_index;
}

//--------------------------------------------------------------------------

CircularPermutation::CircularPermutation(const CircularPermutation &p, int pos, int e) 
  : CombinatorialObject(p, pos, e)
{
  perm = element;
  inverse_perm = element_index;
}

//--------------------------------------------------------------------------

CircularPermutation::~CircularPermutation()
{

}

//--------------------------------------------------------------------------

int CircularPermutation::next_index(int i) const
{
  if(i == num_elements) return 1;
  return i+1;
}

//--------------------------------------------------------------------------

int CircularPermutation::previous_index(int i) const
{
  if(i==1) return num_elements;
  return i-1;
}

//--------------------------------------------------------------------------
// --------- Partial Solution Support
//--------------------------------------------------------------------------

int CircularPermutation::first_position() const { return 2; }

//--------------------------------------------------------------------------

int CircularPermutation::last_position() const { return get_permutation_size() + 1; }

//--------------------------------------------------------------------------
ostream &operator<<( ostream & out, const CircularPermutation & It)
{
  out <<"(circular_permutation, ";
  out << (CombinatorialObject) It << ")\n";
  return out;
}
//--------------------------------------------------------------------------
