/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/
#ifndef CIRCULAR_PERMUTATION_H
#define CIRCULAR_PERMUTATION_H

#include "basic_types.h"
#include "combinatorial_object.h"

/**
a type of combinatorial object; can not manipulate refCount.
@author Vinhthuy Phan
@version 1.0
*/
class CircularPermutation : public CombinatorialObject  {
  friend ostream &operator<<( ostream & out, const CircularPermutation & It);

public:
  ///
  int *perm;
  ///
  int *inverse_perm;
  
  ///
  int get_permutation_size() const {
    if(perm == NULL) return 0;
    return num_elements;
  }

  ///
  CircularPermutation();

  ///
  CircularPermutation(int n);
  
  ///
  CircularPermutation(const CircularPermutation &p);
  
  ///
  CircularPermutation(const CircularPermutation &p, int pos, int ele);
  
  /// --- partial solution support ---
  int first_position() const;
  /// --- partial solution support ---
  int last_position() const;

  ///
  ~CircularPermutation();
  
  ///
  void display(ostream & out, int flag=-1) const;

  //  int first_index() const;
  //  int last_index() const;
  ///
  int next_index(int i) const;
  ///
  int previous_index(int i) const;

};

#endif
