/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/
#include "date.h"

Date::Date(double d)
{
  this->time = d;
}


Date::Date()
{
  struct timeb tp;
  ftime(&tp);
  this->time = tp.time + ((double) tp.millitm / 1000.0);
}


double Date::get_time()
{
  return time;
}

Date::~Date(){  }

Date Date::operator= (const Date & d)
{
  if(&d != this) this->time = d.time;
  return (*this);
}

Date Date::operator= (double sec)
{
  this->time = sec;
  return (*this);
}

Date Date::operator+ (Date & d)
{
  return Date(this->time + d.time);
}

Date Date::operator+ (double & sec)
{
  return Date(this->time + sec);
}

Date Date::operator- (Date & d)
{
  if(*this < d) return Date(0);
  else return Date(this->time - d.time);
}

bool Date::operator< (Date & d)
{
  if(this->time < d.time) return true;
  else return false;
}

bool Date::operator> (Date & d)
{
  if(this->time > d.time) return true;
  else return false;
}
//-----------------------------------------------------------------------------

#if 0
SysTime::SysTime()
{
  struct rusage tp;
  getrusage(RUSAGE_SELF, &tp);
  
  this->time = tp.ru_utime.tv_sec + tp.ru_stime.tv_sec +
    (tp.ru_utime.tv_usec + tp.ru_stime.tv_usec) / 1e6 ;
}


double SysTime::get_time()
{
  return time;
}

SysTime::~SysTime(){  }
#endif
