/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/
#ifndef DATE_H
#define DATE_H


#include <time.h>
#include <sys/timeb.h>
//#include <sys/time.h>
#include <sys/resource.h>
//#include <unistd.h>
#include <math.h>


/**
@author Vinhthuy Phan
@version 1.0
*/
class Date {
private:
  ///
  double time;

public:
  ///
  Date(double date);

  /// initialize time to be current time.
  Date();

  ///
  ~Date();

	
  ///
  Date operator= (const Date & date);

  ///
  Date operator= (double sec);

  ///
  Date operator+ (Date & date);
	
  ///
  Date operator+ (double & sec);
	
  ///
  Date operator- (Date & date);

  ///
  bool operator< (Date & date);

  ///
  bool operator> (Date & date);
  
  ///
  double get_time();
};



/**
@author Vinhthuy Phan
@version 1.0
*/
#if 0
class SysTime {
private:
  /// The time in seconds.
  double time;
public:
  
  /// initialize time to be current time.
  SysTime();
  
  ///
  ~SysTime();

  /// return the time in seconds.
  double get_time();
};
#endif
#endif
