/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/

#include <cstdlib>
#include <iostream>
using std::cout;
using std::cerr;
using std::endl;
#include "errors.h"


void error_call(error_type error1)
{
  switch(error1){
    
  case bad_growth_operation:
    cerr << endl;
    cerr << "A bad mutator or crossover operation requested......" << endl;
    
    exit(1);
    break;
    
  case bad_allocation:
    cerr << endl;
    cerr << "Bad memory allocation......" << endl;
    
    exit(2);
    break;
    
  case missing_weights:
    cerr << endl;
    cerr << "Missing Weights....."<< endl;
    
    exit(3);
    break;
    
  case bad_weights:
    cerr << endl;
    cerr << "Illegal weights...." << endl;
    
    exit(4);
    break;
  case bad_file:
    cerr << endl;
    cerr << "Could not open the input file or bad elements in it...." << endl;
    
    exit(5);
    break;
  case bad_index:
    cerr << endl;
    cerr << "Index does not exist...." << endl;
    
    exit(6);
  case bad_option:
    cerr << endl;
    cerr << "Bad options...." << endl;
    
    exit(7);
  case bad_engine:
    cerr << endl;
    cerr << "Bad Engine...." << endl;
    
    exit(8);
  case bad_gml_file:
    cerr << endl;
    cerr << "Bad Input File...." << endl;
    
    exit(8);
    
  case no_heuristic:
    cerr << endl;
    cerr << "User must specify a search heuristic (hill_climb, simulated_annealing,...).\n";
    exit(9);

  case no_solution_type:
    cerr << endl;
    cerr << "User must specify a solution type (permutation, set, ...).\n";
    exit(10);

  default:
    cerr << endl;
    cerr << "No error message for this error." << endl;
    
    exit(99);
  }
}

