/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/
#ifndef ErrorFunction
#define ErrorFunction

//#include <iostream>
//#include <stdlib.h>
//using std::cerr;
//using std::endl;

/**This enumerated type is used to indicate error type.
@param bad_growth_operation
Called when the evolutionary operation is not understood.

@param bad_allocation
Called when a bad memory allocation was performed.

@param missing_weights
Called when one of the graphs edges is missing.

@param bad_weights
Called when an illegal weight type was issued. Legal weight types are
integers and floats.
*/
enum error_type {bad_growth_operation, bad_allocation, missing_weights,
		 bad_weights, bad_file, bad_index, bad_option, bad_engine, bad_gml_file,
		 no_heuristic, no_solution_type};

/**The Function is used by the system to control error flow.
It terminates the program with an exit(1)
@param error1
The enumerated type indicates the type of error.
*/
void error_call(error_type error1);


#endif
