/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/
#include <iostream>
#include "monitor.h"

double Monitor::solution_count = 0;

//----------------------------------------------------------------------------------------
Monitor::Monitor(Monitoring_mode flag,
		 double running_time,
		 double report_interval,
		 double check_progress_interval,
		 Date *starting_time)
{
  monitor_flag = flag;
  this->report_interval = report_interval;
  this->check_progress_interval = check_progress_interval;
  //  stop_flag = report_flag = check_progress_flag = false;

  Date now;
  this->report_time = now + report_interval;
  this->check_progress_time = now + check_progress_interval;

  if(starting_time == NULL)  this->starting_time = now;
  else this->starting_time = *starting_time;

  this->completion_time = now + running_time;

  //  cout<< "#Monitor::Monitor():  running_time, completion_time "
  //      << running_time <<" "<< (this->completion_time).get_time() <<endl;

}
//----------------------------------------------------------------------------------------
MonitorStat Monitor::get_status() const
{
  return status;
}
//----------------------------------------------------------------------------------------
//---- the order and arrangement of the if's is important to have efficent result
//----------------------------------------------------------------------------------------
bool Monitor::block()
{
  Date now;

  if(this->completion_time < now){
    //    cout<<"set terminate\n";
    status.set(stat_terminate);
  }

  if(monitor_flag == search_mode && this->check_progress_time < now){
    //    cout<<"set checkprogres\n";
    status.set(stat_check_progress);
    this->check_progress_time = now + check_progress_interval;
  }
  
  if(monitor_flag == search_mode && this->report_time < now){
    //    cout<<"set report\n";
    status.set(stat_report);
    this->report_time = now + report_interval;
  }

  if(status.count() > 0) return true;

  solution_count += 1.0;
  return false;
}
//----------------------------------------------------------------------------------------
double Monitor::exec_time()
{
  Date now;
  now = now - starting_time;
  return now.get_time();
}
//----------------------------------------------------------------------------------------
double Monitor::time_left()
{
  Date now;
  now = this->completion_time - now;
  return now.get_time();
}
//----------------------------------------------------------------------------------------
Date & Monitor::get_starting_time() 
{
  return starting_time;
}
//----------------------------------------------------------------------------------------
double Monitor::get_report_interval() const
{
  return report_interval;
}
//----------------------------------------------------------------------------------------
double Monitor::get_check_progress_interval() const
{
  return check_progress_interval;
}
//----------------------------------------------------------------------------------------
Date & Monitor::get_termination_time()
{
  return completion_time;
}
//----------------------------------------------------------------------------------------
double Monitor::get_solution_count() { return solution_count; }
//----------------------------------------------------------------------------------------

void Monitor::reset_status(Status which)
{
  status.reset(which);
}
//----------------------------------------------------------------------------------------
void Monitor::set_check_progress_interval(double i)
{
  check_progress_interval = i;
}
//----------------------------------------------------------------------------------------
