/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/

#ifndef MONITOR_H
#define MONITOR_H

#include "date.h"
#include "basic_types.h"
#include <string.h>

//----------------------------------------------------------------------------------------
// MONITOR
//----------------------------------------------------------------------------------------
/**
keeps track of when to report, quite, and check for non-progress.
@author Vinhthuy Phan
@version 1.0
*/
class Monitor {

private:
  ///
  double report_interval;
  ///
  double check_progress_interval;
  ///
  Date starting_time;
  ///
  Date check_progress_time;
  ///
  Date report_time;
  ///
  Date completion_time;  

  //  bool stop_flag, report_flag, check_progress_flag;
  ///
  MonitorStat status;
  ///
  static double solution_count;
  ///
  Monitoring_mode monitor_flag;

public:
  ///
  Monitor(Monitoring_mode flag,
	  double running_time = 0,
	  double report_interval = 0,
	  double check_progress_interval = 0,
	  Date *starting_time = NULL);

  ///
  void reset_status(Status which);
  ///
  MonitorStat get_status () const;
  ///
  bool block();
  ///
  static double get_solution_count() ;
  ///
  Date & get_termination_time();
  ///
  double get_check_progress_interval() const;
  ///
  double get_report_interval() const;
  ///
  Date & get_starting_time();
  ///
  double time_left();
  ///
  double exec_time();
  ///
  void set_check_progress_interval(double i);
};

#endif
