/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/
//--------------------------------------------------------------------
//
// Permutation.cpp: implementation of the Permutation class.
//
//--------------------------------------------------------------------

#include "permutation.h"

//--------------------------------------------------------------------------
//---- Main constructor
//--------------------------------------------------------------------------
Permutation::Permutation() : CombinatorialObject()
{
  perm = element;
  inverse_perm = element_index;
}
//--------------------------------------------------------------------------
Permutation::Permutation(int n) : CombinatorialObject(n)
{
  perm = element;
  inverse_perm = element_index;
}
//--------------------------------------------------------------------------
//---- Copy constructor
//--------------------------------------------------------------------------
Permutation::Permutation(const Permutation &p) : CombinatorialObject(p)
{
  perm = element;
  inverse_perm = element_index;
}

//--------------------------------------------------------------------------

Permutation::Permutation(const Permutation &p , int pos, int e) : CombinatorialObject(p, pos, e)
{
  perm = element;
  inverse_perm = element_index;
}

//--------------------------------------------------------------------------

Permutation::~Permutation()
{

}

//--------------------------------------------------------------------------
// --------- Partial Solution Support
//--------------------------------------------------------------------------

int Permutation::first_position() const
{ 
  return 1;
}

//--------------------------------------------------------------------------

int Permutation::last_position() const 
{
  return get_permutation_size() + 1; 
}

//--------------------------------------------------------------------------
ostream &operator<<( ostream & out, const Permutation & It)
{
  out <<"(permutation, ";
  out << (CombinatorialObject) It << ")\n";
  return out;
}
//--------------------------------------------------------------------------

