/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/
#ifndef PERMUTATION_H
#define PERMUTATION_H


//#include <algorithm>
//#include <iostream.h>
//#include <fstream.h>
//#include <vector.h>
//#include <stdlib.h>
#include "basic_types.h"
#include "combinatorial_object.h"

/**
a type of combinatorial object; can not manipulate refCount.
@author Vinhthuy Phan
@version 1.0
*/
class Permutation : public CombinatorialObject {
  friend ostream &operator<<( ostream & out, const Permutation & It);

public:
  ///
  int *perm;
  ///
  int *inverse_perm;
  ///
  int get_permutation_size() const {
    if(perm == NULL) return 0;
    return num_elements;
  }
  ///
  Permutation();
  ///
  Permutation(int n);
  ///
  Permutation(const Permutation &p);
  ///
  Permutation(const Permutation &p, int pos, int ele);
  
  /// ---- partial solution support -----
  int first_position() const;
  ///
  int last_position() const;
  ///
  ~Permutation();
  ///  
  void display(ostream & out, int flag=-1) const;
};

#endif
