/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/
/**
where an optimization problem is defined
@author Vinhthuy Phan
@version 1.0
@see objective_function.h
*/

/*
#define SCS 1
#define PERMUTATION 1
*/
/*
#define MAXSAT 1
#define SUBSET 1
*/
/*
#define COLORING 1
#define PARTITION 1
*/
//-------------------------------------------------------------------------
// REPRESENTATION_FLAG _must_ be one of these:
//-------------------------------------------------------------------------

#if CIRCULARPERMUTATION
#include "circular_permutation.h"
#endif
#if PERMUTATION
#include "permutation.h"
#endif
#if SUBSET
#include "subset.h"
#endif
#if PARTITION
#include "partition.h"
#endif
#if ORDEREDPARTITION
#include "ordered_partition.h"
#endif

//-------------------------------------------------------------------------
// PROBLEM_FLAG _must_ agree with the appropriate flag for each problem:
//-------------------------------------------------------------------------

#if TSP
#include "TSP/tsp_graphs.h"
typedef Graph InputType;
#endif

#if QA
#include "QA/qa_graph.h"
typedef QAgraph InputType;
#endif

#if SCS
#include "SCS/strings.h"
typedef String InputType;
#endif

#if BANDWIDTH
#include "BANDWIDTH/unweighted_adjacency_list.h"
typedef Graph InputType;
#endif

#if MAXSAT
#include "MAXSAT/clauses.h"
typedef Clause InputType;
#endif

#if MAXCUT
#include "MAXCUT/maxcut_graphs.h"
typedef weighted_graph InputType;
#endif

#if VC
#include "VC/vc_graph.h"
typedef UndirectedGraph InputType;
#endif

#if COLORING
#include "G-COLORING/edge_graph.h"
typedef EdgeGraph InputType;
#endif

#if BW_COLORING
#include "BW-COLORING/bw-edge-graph.h"
typedef EdgeGraph InputType;
#endif

//----------------------------------------------------------------------------------------
