/*
Copyright (C) 2003 copyrighted by SUNY at Stony Brook.

DISCROPT is created by Vinhthuy Phan, Pavel Sumazin, and Steven Skiena.
The authors grant permision to use and distribute WITHOUT ANY WARRANTY
this software for non-commercial purposes, provided that this copyright 
notice is clearly shown.  Other uses are prohibited without prior written
consent.  These terms are applied to any modification of this software 
as well.  See http://www.cs.sunysb.edu/~discropt.

*/
#ifndef SUBSET_H
#define SUBSET_H

#include <set>
#include "basic_types.h"
#include "combinatorial_object.h"

typedef std::set<int> subset;

/**
a type of combinatorial object; can not manipulate refCount.
@author Vinhthuy Phan
@version 1.0
*/
class Subset : public CombinatorialObject {
  friend ostream &operator<<( ostream & out, const Subset & It);

public:
  ///
  subset * subs;
  ///
  subset * subs_compl;
  ///
  bool * element_indicator;
  ///
  int subset_size;
  ///
  int get_subset_size() const {
    return subset_size;
  }
  ///
  int get_size() const {
    return subset_size;
  }
  ///
  Subset();
  ///
  Subset(int n);
  ///
  Subset(const Subset &p);
  ///
  Subset(const Subset &p, int pos, int ele);

  /// --- partial solution support -----
  int first_position() const;
  ///
  int last_position() const;
  ///
  ~Subset();
  ///
  bool contains(int e) const;
  ///
  subset * get_subset();
  ///
  subset * get_subset_complement();

};

#endif
